diff -Naurp gcc/cfgexpand.c gcc/cfgexpand.c
--- gcc/cfgexpand.c	2013-01-11 16:40:46.000000000 +0530
+++ gcc/cfgexpand.c	2013-01-11 22:57:48.000000000 +0530
@@ -1568,11 +1568,12 @@ expand_used_vars (void)
 	     we don't do anything here.  But those which don't contain the
 	     default def (representing a temporary based on the parm/result)
 	     we need to allocate space just like for normal VAR_DECLs.  */
-	  if (!bitmap_bit_p (SA.partition_has_default_def, i))
-	    {
-	      expand_one_var (var, true, true);
-	      gcc_assert (SA.partition_to_pseudo[i]);
-	    }
+         if (TREE_CODE (SSA_NAME_VAR (var)) != PARM_DECL
+          && !bitmap_bit_p (SA.partition_has_default_def, i))
+           {
+             expand_one_var (var, true, true);
+             gcc_assert (SA.partition_to_pseudo[i]);
+           }
 	}
     }
   pointer_map_destroy (ssa_name_decls);
diff -Naurp gcc/testsuite/gcc.dg/pr54218.c gcc/testsuite/gcc.dg/pr54218.c
--- gcc/testsuite/gcc.dg/pr54218.c	1970-01-01 05:30:00.000000000 +0530
+++ gcc/testsuite/gcc.dg/pr54218.c	2013-01-11 22:39:07.000000000 +0530
@@ -0,0 +1,16 @@
+/* { dg-do run } */
+/* { dg-options "-g -fvar-tracking" } */
+/* { dg-skip-if "" { *-*-* }  { "*" } { "-O0" } } */
+
+void func(int p)
+{
+    p = 0; /* { dg-final { gdb-test 8 "p" "0" } } */
+    p = 32;/* { dg-final { gdb-test 8 "p" "42" } } */
+}
+
+int
+main (void)
+{
+    int local = 42;
+    func(local);
+}
